
; PICBASIC PRO(TM) Compiler 2.60, (c) 1998, 2009 microEngineering Labs, Inc. All Rights Reserved. 
_USED			EQU	1

	INCLUDE	"C:\PBP\18F4550.INC"


; Define statements.
#define		OSC		 20          
#define		LOADER_USED		 1

RAM_START       		EQU	00000h
RAM_END         		EQU	003FFh
RAM_BANKS       		EQU	00004h
BANK0_START     		EQU	00060h
BANK0_END       		EQU	000FFh
BANK1_START     		EQU	00100h
BANK1_END       		EQU	001FFh
BANK2_START     		EQU	00200h
BANK2_END       		EQU	002FFh
BANK3_START     		EQU	00300h
BANK3_END       		EQU	003FFh
BANKA_START     		EQU	00000h
BANKA_END       		EQU	0005Fh

FLAGS           		EQU	RAM_START + 000h
R0              		EQU	RAM_START + 001h
R1              		EQU	RAM_START + 003h
R2              		EQU	RAM_START + 005h
R3              		EQU	RAM_START + 007h
R4              		EQU	RAM_START + 009h
R5              		EQU	RAM_START + 00Bh
R6              		EQU	RAM_START + 00Dh
R7              		EQU	RAM_START + 00Fh
R8              		EQU	RAM_START + 011h
GOP             		EQU	RAM_START + 013h
RM1             		EQU	RAM_START + 014h
RM2             		EQU	RAM_START + 015h
RR1             		EQU	RAM_START + 016h
RR2             		EQU	RAM_START + 017h
RS1             		EQU	RAM_START + 018h
RS2             		EQU	RAM_START + 019h
_b               		EQU	RAM_START + 01Ah
_d               		EQU	RAM_START + 01Bh
_USBBufferCount  		EQU	RAM_START + 01Ch
_USBBuffer       		EQU	RAM_START + 01Dh
_PORTL           		EQU	 PORTB
_PORTH           		EQU	 PORTC
_TRISL           		EQU	 TRISB
_TRISH           		EQU	 TRISC

; Constants.
_USBBufferSizeMax		EQU	00008h
_USBBufferSizeTX 		EQU	00008h
_USBBufferSizeRX 		EQU	00008h

; EEPROM data.


	INCLUDE	"PRUEBA~1.MAC"
	INCLUDE	"C:\PBP\PBPUSB18.LIB"

	MOVE?CB	000h, TRISB
	MOVE?CB	0FFh, TRISD
	USBINIT?	

	LABEL?L	_ProgramStart	
	GOSUB?L	_DoUSBIn
	MOVE?BB	_USBBuffer + 00004h, _b
	MOVE?BB	_b, PORTB
	USBSERVICE?	
	MOVE?BB	PORTD, _d
	MOVE?BB	_d, _USBBuffer + 00006h
	GOSUB?L	_DoUSBOut
	GOTO?L	_ProgramStart

	LABEL?L	_DoUSBIn	
	MOVE?CB	_USBBufferSizeRX, _USBBufferCount
	USBSERVICE?	
	USBIN?CBBL	001h, _USBBuffer, _USBBufferCount, _DoUSBIn
	RETURN?	

	LABEL?L	_DoUSBOut	
	MOVE?CB	_USBBufferSizeTX, _USBBufferCount
	USBSERVICE?	
	USBOUT?CBBL	001h, _USBBuffer, _USBBufferCount, _DoUSBOut
	RETURN?	

	END
