
; PICBASIC PRO(TM) Compiler 2.60, (c) 1998, 2009 microEngineering Labs, Inc. All Rights Reserved. 
_USED			EQU	1

	INCLUDE	"C:\PBP\16F877A.INC"


; Define statements.
#define		CODE_SIZE		 8

RAM_START       		EQU	00020h
RAM_END         		EQU	001EFh
RAM_BANKS       		EQU	00004h
BANK0_START     		EQU	00020h
BANK0_END       		EQU	0007Fh
BANK1_START     		EQU	000A0h
BANK1_END       		EQU	000EFh
BANK2_START     		EQU	00110h
BANK2_END       		EQU	0016Fh
BANK3_START     		EQU	00190h
BANK3_END       		EQU	001EFh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	021FFh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
FLAGS           		EQU	RAM_START + 012h
GOP             		EQU	RAM_START + 013h
RM1             		EQU	RAM_START + 014h
RM2             		EQU	RAM_START + 015h
RR1             		EQU	RAM_START + 016h
RR2             		EQU	RAM_START + 017h
T1              		EQU	RAM_START + 018h
_vsal            		EQU	RAM_START + 01Ah
_ancho           		EQU	RAM_START + 01Ch
_b               		EQU	RAM_START + 01Dh
_c               		EQU	RAM_START + 01Eh
_PORTL           		EQU	 PORTB
_PORTH           		EQU	 PORTC
_TRISL           		EQU	 TRISB
_TRISH           		EQU	 TRISC
#define _pwm_pin         	_PORTB??0
#define _PORTB??0        	 PORTB, 000h
#define _PORTA??0        	 PORTA, 000h

; Constants.
_tiempo          		EQU	00028h
_ciclo_pwm       		EQU	00005h
_ciclo           		EQU	00008h
_nivel           		EQU	000C4h
	INCLUDE	"PRO09_8.MAC"
	INCLUDE	"C:\PBP\PBPPIC14.LIB"


	LABEL?L	_Inicio	
	SERIN2DPIN?T	_PORTA??0
	SERIN2MODE?C	0BCh
	SERIN2TIME?C	00Ah

	LABEL?L	L00001	
	SERIN2WAIT?CLL	024h, L00001, _No_Dato
	SERIN2?BL	_b, _No_Dato
	SERIN2?BL	_c, _No_Dato
	CMPNE?BCL	_c, 00Dh, L00002
	MUL?BCW	_b, 002h, _vsal
	MUL?WCW	_vsal, 064h, T1
	DIV?WCB	T1, _nivel, _ancho
	PWM?TBC	_pwm_pin, _ancho, _ciclo
	PAUSE?C	064h
	GOTO?L	_Inicio
	GOTO?L	L00003
	LABEL?L	L00002	
	GOTO?L	_Inicio
	LABEL?L	L00003	

	LABEL?L	_No_Dato	
	GOTO?L	_Inicio

	END
